#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-

import time
import tensorflow as tf

from tensorflow.examples.tutorials.mnist import input_data

NCLASS = 10
NDIMS = 28**2

def model_MLP(nhidden):

  x = tf.placeholder(tf.float32, [None, NDIMS])

  # Layer 1 -> 2
  W1 = tf.Variable(tf.random_normal([NDIMS, nhidden], 0., 0.1))
  b1 = tf.Variable(tf.random_normal([nhidden], 0., 0.1))
  x2 = tf.sigmoid(tf.matmul(x, W1) + b1)

  # Layer 2 -> 3
  W2 = tf.Variable(tf.random_normal([nhidden, NCLASS], 0., 0.1))
  b2 = tf.Variable(tf.random_normal([NCLASS], 0., 0.1))
  y = tf.sigmoid(tf.matmul(x2, W2) + b2)

  # target
  y_ = tf.placeholder(tf.float32, [None, 10])

  # loss
  loss = tf.reduce_mean(tf.square(y-y_))

  # optimization step
  train_step = tf.train.GradientDescentOptimizer(0.5).minimize(loss)

  return (x, y, y_, train_step, loss)
  


def train_and_eval(mnist, model, session):

  (x, y, y_, train_step, loss) = model

  # train
  tf.initialize_all_variables().run()

  before = time.time()
  print 'Starting training...'

  for i in range(1000):

      batch_xs, batch_ys = mnist.train.next_batch(100)
      batch_data = {x: batch_xs, y_: batch_ys}

      _,_loss = session.run((train_step,loss), feed_dict=batch_data)

      
      print('iteration %d: %.2f' %(i, _loss))

  after = time.time()

  print 'Training took %.1f seconds' %(after-before)

  # evaluate test set accuracy
  correct_prediction = tf.equal(tf.argmax(y, 1), tf.argmax(y_, 1))
  accuracy = tf.reduce_mean(tf.cast(correct_prediction, tf.float32))
  print 'accuracy', (session.run(accuracy, feed_dict={x: mnist.test.images,
                                                      y_: mnist.test.labels}))

  

def main():
  mnist = input_data.read_data_sets('data', one_hot=True)
  model = model_MLP(nhidden=300)
  session = tf.InteractiveSession()
  train_and_eval(mnist, model, session)



if __name__ == '__main__':
  main()
